#ifndef _NEIGHBORJOIN_H_
#define _NEIGHBORJOIN_H_
#include "RNAStruct.h"


class TNode {
public:
	int pt; //point to 
	TNode() {pt = -1;}
	TNode(const int & in_pt) {pt = in_pt;}
	~TNode() {}
	void reset() {pt = -1;} 
};

class mytable {
public:
	int original_num;  //the number of original OTUs
	int valid_num;     //the number of OTUs remain valid
	vector<bool> valid;//indicate whether column x and row x are valid, e.g. valid[i]==false --> matrix[i][.] and maxtrix[j][.] are invalid
	vector<TNode> tree;
	vector< vector<double> > D; //the distance matrix
	vector<double> drow;      //the sum of distances in each row
	
	mytable() {original_num=0;}
	mytable( vector<vector<double> > & in_D);
	~mytable() {}
	vector<int>   DJ(const int & knum, const vector<RNA> & vrna, ofstream & fout, vector<int> & vorder); //join neighbors according to the distance between structures.
	void   show();
	void   showtree(const int & n, const int & indent);
	vector<int> cluster2k(const int & k);//split the whole tree into k parts
		
private:
	void   pickminD(int & indx_i, int & indx_j);//Pick a pair i,j for which matrix[i][j] is the smallest among all the cells that are valid.	
};
#endif
